import { type Ref, defineComponent, inject, ref } from 'vue';
import { useI18n } from 'vue-i18n';
import { useRoute, useRouter } from 'vue-router';

import { useAlertService } from '@/shared/alert/alert.service';
import { useDateFormat } from '@/shared/composables';
import { type IPrenotazione } from '@/shared/model/prenotazione.model';

import PrenotazioneService from './prenotazione.service';

export default defineComponent({
  name: 'PrenotazioneDetails',
  setup() {
    const dateFormat = useDateFormat();
    const prenotazioneService = inject('prenotazioneService', () => new PrenotazioneService());
    const alertService = inject('alertService', () => useAlertService(), true);

    const route = useRoute();
    const router = useRouter();

    const previousState = () => router.go(-1);
    const prenotazione: Ref<IPrenotazione> = ref({});

    const retrievePrenotazione = async prenotazioneId => {
      try {
        const res = await prenotazioneService().find(prenotazioneId);
        prenotazione.value = res;
      } catch (error) {
        alertService.showHttpError(error.response);
      }
    };

    if (route.params?.prenotazioneId) {
      retrievePrenotazione(route.params.prenotazioneId);
    }

    return {
      ...dateFormat,
      alertService,
      prenotazione,

      previousState,
      t$: useI18n().t,
    };
  },
});
